unit Unit1;

interface

{$IFDEF VCL}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
{$ELSE}
uses
  SysUtils, Classes, QGraphics, QControls,
  QForms, QStdCtrls, QMenus, QDialogs;
{$ENDIF}


type
  TForm1 = class(TForm)
    Label1: TLabel;
    btnShow: TButton;
    btnHide: TButton;
    btnModal: TButton;
    Label2: TLabel;
    btnDialog: TButton;
    btnSizeable: TButton;
    btnTool: TButton;
    btnSizeTool: TButton;
    Label3: TLabel;
    btnSystem: TButton;
    btnMaximize: TButton;
    btnNormal: TButton;
    btnMinimized: TButton;
    btnMaximized: TButton;
    Label4: TLabel;
    procedure btnShowClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnHideClick(Sender: TObject);
    procedure btnModalClick(Sender: TObject);
    procedure btnDialogClick(Sender: TObject);
    procedure btnSizeableClick(Sender: TObject);
    procedure btnToolClick(Sender: TObject);
    procedure btnSizeToolClick(Sender: TObject);
    procedure btnSystemClick(Sender: TObject);
    procedure btnMaximizeClick(Sender: TObject);
    procedure btnNormalClick(Sender: TObject);
    procedure btnMinimizedClick(Sender: TObject);
    procedure btnMaximizedClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.btnShowClick(Sender: TObject);
begin
  Form2.Show; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BorderStyle := fbsDialog;
end;

procedure TForm1.btnHideClick(Sender: TObject);
begin
  Form2.Hide;
end;

procedure TForm1.btnModalClick(Sender: TObject);
var
  ModalResult: Integer;
  S: string;
begin
  ModalResult := Form2.ShowModal;
  case ModalResult of
    mrNone: S := 'mrNone';
    mrOK: S := 'mrOK';
    mrCancel: S := 'mrCancel';
  else
    S := 'unknown';
  end;
  ShowMessage(Format('The modal result is: ''%s'' = %d', [S, ModalResult]));
end;

procedure TForm1.btnDialogClick(Sender: TObject);
begin
  Form2.BorderStyle := fbsDialog;
end;

procedure TForm1.btnSizeableClick(Sender: TObject);
begin
  Form2.BorderStyle := fbsSizeable;
end;

procedure TForm1.btnToolClick(Sender: TObject);
begin
  Form2.BorderStyle := fbsToolWindow;
end;

procedure TForm1.btnSizeToolClick(Sender: TObject);
begin
  Form2.BorderStyle := fbsSizeToolWin;
end;

procedure TForm1.btnSystemClick(Sender: TObject);
begin
  if biSystemMenu in Form2.BorderIcons then
    Form2.BorderIcons := Form2.BorderIcons - [biSystemMenu]
  else
    Form2.BorderIcons := Form2.BorderIcons + [biSystemMenu];
end;

procedure TForm1.btnMaximizeClick(Sender: TObject);
begin
  if biMaximize in Form2.BorderIcons then
    Form2.BorderIcons := Form2.BorderIcons - [biMaximize]
  else
    Form2.BorderIcons := Form2.BorderIcons + [biMaximize];
end;

procedure TForm1.btnNormalClick(Sender: TObject);
begin
  Form2.WindowState := wsNormal;
end;

procedure TForm1.btnMinimizedClick(Sender: TObject);
begin
  Form2.WindowState := wsMinimized;
end;

procedure TForm1.btnMaximizedClick(Sender: TObject);
begin
  Form2.WindowState := wsMaximized;
end;

end.
