unit Unit1;

interface

{$IFDEF VCL}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;
{$ELSE}
uses
  SysUtils, Classes, QGraphics, QControls,
  QForms, QStdCtrls, QMenus, QDialogs;
{$ENDIF}


type
  TForm1 = class(TForm)
    lblMouseAction: TLabel;
    btnClearLbl: TButton;
    btnEnabled: TButton;
    btnVisible: TButton;
    btnSize: TButton;
    btnPosition: TButton;
    lblLeft: TLabel;
    edtLeft: TEdit;
    lblHeight: TLabel;
    edtTop: TEdit;
    lblTop: TLabel;
    lblWidht: TLabel;
    edtWidth: TEdit;
    edtHeight: TEdit;
    ListBox1: TListBox;
    btnAdd: TButton;
    btnRemove: TButton;
    btnInsert: TButton;
    btnReplace: TButton;
    btnClear: TButton;
    btnSort: TButton;
    Edit3: TEdit;
    lblText: TLabel;
    Edit2: TEdit;
    lblIndex: TLabel;
    Edit1: TEdit;
    btnGetIndex: TButton;
    btnSetIndex: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1Click(Sender: TObject);
    procedure btnClearLblClick(Sender: TObject);
    procedure btnEnabledClick(Sender: TObject);
    procedure btnVisibleClick(Sender: TObject);
    procedure btnSizeClick(Sender: TObject);
    procedure btnPositionClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnGetIndexClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure btnReplaceClick(Sender: TObject);
    procedure btnSetIndexClick(Sender: TObject);
    procedure btnSortClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BorderStyle := fbsDialog;
  edtLeft.Text := IntToStr(ListBox1.Left);
  edtTop.Text := IntToStr(ListBox1.Top);
  edtWidth.Text := IntToStr(ListBox1.Width);
  edtHeight.Text := IntToStr(ListBox1.Height);
end;

procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + '[';
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + '.';
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  lblMouseAction.Caption := lblMouseAction.Caption + ']';
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  Index: Integer;
begin
  lblMouseAction.Caption := lblMouseAction.Caption + 'O';

  Index := ListBox1.ItemIndex;
  if Index <> -1 then
    Edit3.Text := ListBox1.Items[Index];
end;

procedure TForm1.btnClearLblClick(Sender: TObject);
begin
  lblMouseAction.Caption := '';
end;

procedure TForm1.btnEnabledClick(Sender: TObject);
begin
  ListBox1.Enabled := not ListBox1.Enabled;
end;

procedure TForm1.btnVisibleClick(Sender: TObject);
begin
  ListBox1.Visible := not ListBox1.Visible;
end;

procedure TForm1.btnSizeClick(Sender: TObject);
begin
  ListBox1.Width := StrToInt(edtWidth.Text);
  ListBox1.Height := StrToInt(edtHeight.Text);
  edtWidth.Text := IntToStr(ListBox1.Width);
  edtHeight.Text := IntToStr(ListBox1.Height);
end;

procedure TForm1.btnPositionClick(Sender: TObject);
begin
  ListBox1.Left := StrToInt(edtLeft.Text);
  ListBox1.Top := StrToInt(edtTop.Text);
  edtLeft.Text := IntToStr(ListBox1.Left);
  edtTop.Text := IntToStr(ListBox1.Top);
end;

procedure TForm1.btnAddClick(Sender: TObject);
var
  S: string;
  Count: Integer;
begin
  Count := ListBox1.Items.Count;
  S := Format('%s [%d]', [Edit2.Text, Count]);
  ListBox1.Items.Add(S);
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  ListBox1.Clear;
end;

procedure TForm1.btnGetIndexClick(Sender: TObject);
begin
  Edit1.Text := IntToStr(ListBox1.ItemIndex);
end;

procedure TForm1.btnInsertClick(Sender: TObject);
var
  Count: Integer;
  Index: Integer;
  S: string;
begin
  Count := ListBox1.Items.Count;
  S := Format('%s [%d]', [Edit2.Text, Count]);
  Index := StrToInt(Edit1.Text);
  ListBox1.Items.Insert(Index, S);
end;

procedure TForm1.btnRemoveClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := StrToInt(Edit1.Text);
  ListBox1.Items.Delete(Index);
end;

procedure TForm1.btnReplaceClick(Sender: TObject);
var
  Index: Integer;
  S: string;
begin
  Index := StrToInt(Edit1.Text);
  S := Format('%s [%d]', [Edit2.Text, Index]);
  ListBox1.Items[Index] := S;
end;

procedure TForm1.btnSetIndexClick(Sender: TObject);
begin
  ListBox1.ItemIndex := StrToInt(Edit1.Text);
end;

procedure TForm1.btnSortClick(Sender: TObject);
begin
  ListBox1.Sort;
end;


end.
