
{*******************************************************}
{                                                       }
{ Demo project for use of Modbus/TCP client component   }
{ TModbusTcpClient                                      }
{ frmuMain.pas                                          }
{                                                       }
{ for Delphi 5, 6, 7                                    }
{ Copyright (c) 2000-2003 by Team-DWP                   }
{ e-mail: team-dwp@dwp42.org                            }
{ www: http://www.dwp42.org                             }
{                                                       }
{ The initial developer of the code is                  }
{   Immo Wache, immo.wache@dwp42.org                    }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ Licensees holding a valid Team-DWP No-Nonsense        }
{ License for this Software may use this file in        }
{ accordance with such license, which appears in        }
{ the file license.txt that came with this software.    }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/demos/clx/modbustcp/client/frmuMain.pas,v 1.1 2003/11/06 20:29:23 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: frmuMain.pas,v $
  Revision 1.1  2003/11/06 20:29:23  iwache
  Demo project for use of Modbus/TCP client component added.

  ----------------------------------------------------------------------------
}

unit frmuMain;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls,
  QForms, QDialogs, QStdCtrls, ModbusCtrls, QMenus;

resourcestring
  sCaptionBitCount = 'Bit &Count:';
  sCaptionRegisterCount = 'Register &Count:';
  sModbusIsOpenError = 'Modbus socket error: socket is open';

const
  DBytePerLine = 8;
  DWordPerLine = 4;

type
  TValueSize =(vsByte, vsWord);

  TParameter = (pmRefNum, pmCount, pmReadRefNum, pmReadCount, pmBitValue,
      pmRegisterValue, pmData);
  TParameters = set of TParameter;

  TfrmMain = class(TForm)
    lblRemoteHost: TLabel;
    edtRemoteHost: TEdit;
    btnClear: TButton;
    btnExecute: TButton;
    lbxOutput: TListBox;
    cboFunction: TComboBox;
    lblFunction: TLabel;
    edtTransactionId: TEdit;
    lblTransactionId: TLabel;
    cbxAutoIncrement: TCheckBox;
    lblUnitId: TLabel;
    edtUnitId: TEdit;
    edtRefNum: TEdit;
    lblRefNum: TLabel;
    lblCount: TLabel;
    edtCount: TEdit;
    lblRegisterValue: TLabel;
    lblBitValue: TLabel;
    cboBitValue: TComboBox;
    edtRegisterValue: TEdit;
    lblReadCount: TLabel;
    edtReadCount: TEdit;
    edtData0: TEdit;
    lblData0: TLabel;
    lblData4: TLabel;
    edtData4: TEdit;
    lblData1: TLabel;
    edtData1: TEdit;
    lblData2: TLabel;
    edtData2: TEdit;
    lblData3: TLabel;
    edtData3: TEdit;
    lblData5: TLabel;
    edtData5: TEdit;
    lblData6: TLabel;
    edtData6: TEdit;
    lblData7: TLabel;
    edtData7: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    ClearOutput1: TMenuItem;
    Execute1: TMenuItem;
    lblReadRefNum: TLabel;
    edtReadRefNum: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnExecuteClick(Sender: TObject);
    procedure cboFunctionChange(Sender: TObject);
    procedure edtRefNumChange(Sender: TObject);
    procedure edtRefNumExit(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    ModbusTcpClient1: TModbusTcpClient;
    FBytePerLine: Integer;
    FWordPerLine: Integer;
    FValueSize: TValueSize;
    FStartTime: TDateTime;

    procedure ModbusTcpClient1SocketError(Sender: TObject; SocketError: Integer);
    procedure ModbusTcpClient1SocketConnect(Sender: TObject);
    procedure ModbusTcpClient1SocketDisconnect(Sender: TObject);
    procedure ModbusTcpClient1SocketConnectionAborted(Sender: TObject);

    function GetBitValue: Boolean;
    function GetByteCount: Integer;
    function GetRefNum: Word;
    function GetRegisterValue: Word;
    function GetTransactionId: Word;
    function GetUnitId: Byte;
    function GetCount: Word;
    function GetReadRefNum: Word;
    function GetReadCount: Word;

    procedure SetCount(const Value: Word);
    procedure SetBitValue(const Value: Boolean);
    procedure SetBytePerLine(const Value: Integer);
    procedure SetRefNum(const Value: Word);
    procedure SetRegisterValue(const Value: Word);
    procedure SetTransactionId(const Value: Word);
    procedure SetUnitId(const Value: Byte);
    procedure SetWordPerLine(const Value: Integer);
    procedure SetReadRefNum(const Value: Word);
    procedure SetReadCount(const Value: Word);

    procedure ShowEmptyLine;
    procedure ShowFunctionHead(TransactionId: Word; UnitId: Byte; FunctionCode:
        Byte = 0);
    procedure ShowLine(const S: string);
    procedure DumpByteArray(Address: Integer; Data: array of Byte);
    procedure DumpWordArray(Address: Integer; Data: array of Word);
    procedure SetParameters(Parameters: TParameters);

    procedure DoReadCoils;
    procedure DoForceMultipleCoils;
    procedure DoGetCommEventCounter;
    procedure DoReadExceptionStatus;
    procedure DoReadInputDiscretes;
    procedure DoReadInputRegisters;
    procedure DoReadMultipleRegisters;
    procedure DoWriteCoil;
    procedure DoWriteMultipleRegisters;
    procedure DoReadWriteRegisters;
    procedure DoWriteSingleRegister;

    procedure ModbusTcpClient1Exception(Sender: TObject;
        TransactionId: Word; UnitId, FunctionCode, ExceptionCode: Byte);
    procedure ModbusTcpClient1Response(Sender: TObject;
        TransactionId: Word; UnitId, FunctionCode: Byte; Data: array of Byte);
    procedure ModbusTcpClient1ReadCoils(Sender: TObject;
        TransactionId: Word; UnitId: Byte; Data: array of Byte);
    procedure ModbusTcpClient1ForceMultipleCoils(Sender: TObject;
        TransactionId: Word; UnitId: Byte; RefNum, BitCount: Word);
    procedure ModbusTcpClient1GetCommEventCounter(Sender: TObject;
        TransactionId: Word; UnitId: Byte; Status, Count: Word);
    procedure ModbusTcpClient1ReadExceptionStatus(Sender: TObject;
        TransactionId: Word; UnitId, Status: Byte);
    procedure ModbusTcpClient1ReadInputDiscretes(Sender: TObject;
        TransactionId: Word; UnitId: Byte; Data: array of Byte);
    procedure ModbusTcpClient1ReadInputRegisters(Sender: TObject;
        TransactionId: Word; UnitId: Byte; Data: array of Word);
    procedure ModbusTcpClient1ReadMultipleRegisters(Sender: TObject;
        TransactionId: Word; UnitId: Byte; Data: array of Word);
    procedure ModbusTcpClient1WriteCoil(Sender: TObject;
        TransactionId: Word; UnitId: Byte; RefNum: Word; Value: Boolean);
    procedure ModbusTcpClient1WriteMultipleRegisters(Sender: TObject;
        TransactionId: Word; UnitId: Byte; RefNum, WordCount: Word);
    procedure ModbusTcpClient1WriteSingleRegister(Sender: TObject;
        TransactionId: Word; UnitId: Byte; RefNum, Value: Word);
    procedure ModbusTcpClient1ReadWriteRegisters(Sender: TObject; TransactionId: 
        Word; UnitId: Byte; Data: array of Word);

    function GetedtData(Index: Integer): TEdit;
    function GetlblData(Index: Integer): TLabel;
    function GetDataCaption(Index: Integer): string;
    procedure FillcboFunction;
    procedure ApplicationIdle(Sender: TObject; var Done: Boolean);
    property edtData[Index: Integer]: TEdit read GetedtData;
    property lblData[Index: Integer]: TLabel read GetlblData;
  public
    property BitValue: Boolean read GetBitValue write SetBitValue;
    property ByteCount: Integer read GetByteCount;
    property BytePerLine: Integer read FBytePerLine write SetBytePerLine default
        DBytePerLine;
    property RefNum: Word read GetRefNum write SetRefNum;
    property RegisterValue: Word read GetRegisterValue write SetRegisterValue;
    property TransactionId: Word read GetTransactionId write SetTransactionId;
    property UnitId: Byte read GetUnitId write SetUnitId;
    property WordPerLine: Integer read FWordPerLine write SetWordPerLine default
        DWordPerLine;
    property Count: Word read GetCount write SetCount;
    property ValueSize: TValueSize read FValueSize write FValueSize;
    property ReadRefNum: Word read GetReadRefNum write SetReadRefNum;
    property ReadCount: Word read GetReadCount write SetReadCount;
  end;

var
  frmMain: TfrmMain;

implementation

uses
{$IFDEF DOS}
  {$IFDEF WDOSX}
  WDosClock,
  {$ENDIF}
  {$IFDEF WIN}
  Windows,
  {$ENDIF}
{$ELSE}
  MMSystem,
{$ENDIF}
  Sockets, SocketUtils;

{$R *.xfm}

{
 ***************************** common functions ********************************
}

function GetTimeCounter: Integer;
begin
{$IFDEF DOS}
  {$IFDEF WDOSX}
  Result := GetMSCounter;
  {$ENDIF}
  {$IFDEF WIN}
  Result := GetTickCount;
  {$ENDIF}
{$ELSE}
  Result := timeGetTime;
{$ENDIF}
end;

function BooleanToStr(Value: Boolean): string;

  const sBoolean: array[Boolean] of string = (
    'False', 'True');

begin
  Result :=sBoolean[Value];
end;

function IndexToModbusFunction(Value: Integer): Integer;

  const ModbusFunction: array[0..10] of Integer =(
    READ_COILS,               READ_INPUT_DISCRETES,
    READ_MULTIPLE_REGISTERS,  READ_INPUT_REGISTERS,
    WRITE_COIL,               WRITE_SINGLE_REGISTER,
    READ_EXCEPTION_STATUS,    GET_COMM_EVENT_COUNTER,
    FORCE_MULTIPLE_COILS,     WRITE_MULTIPLE_REGISTERS,
    READ_WRITE_REGISTERS);

begin
  Result :=ModbusFunction[Value];
end;

{
 ***************************** TfrmMain ****************************************
}
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Application.OnIdle := ApplicationIdle;

  FBytePerLine :=DBytePerLine;
  FWordPerLine :=DWordPerLine;
  cboBitValue.ItemIndex :=0;

  FillcboFunction;
  cboFunction.ItemIndex :=0;
  cboFunctionChange(cboFunction);

  ModbusTcpClient1 := TModbusTcpClient.Create(Self);
  with ModbusTcpClient1 do
  begin
    OnSocketError := ModbusTcpClient1SocketError;
    OnSocketConnect := ModbusTcpClient1SocketConnect;
    OnSocketDisconnect := ModbusTcpClient1SocketDisconnect;
    OnSocketConnectionAborted := ModbusTcpClient1SocketConnectionAborted;

    OnException := ModbusTcpClient1Exception;
    OnResponse := ModbusTcpClient1Response;

    OnReadCoils := ModbusTcpClient1ReadCoils;
    OnForceMultipleCoils := ModbusTcpClient1ForceMultipleCoils;
    OnGetCommEventCounter := ModbusTcpClient1GetCommEventCounter;
    OnReadExceptionStatus := ModbusTcpClient1ReadExceptionStatus;
    OnReadInputDiscretes := ModbusTcpClient1ReadInputDiscretes;
    OnReadInputRegisters := ModbusTcpClient1ReadInputRegisters;
    OnReadMultipleRegisters := ModbusTcpClient1ReadMultipleRegisters;
    OnWriteCoil := ModbusTcpClient1WriteCoil;
    OnWriteMultipleRegisters := ModbusTcpClient1WriteMultipleRegisters;
    OnWriteSingleRegister := ModbusTcpClient1WriteSingleRegister;
    OnReadWriteRegisters := ModbusTcpClient1ReadWriteRegisters;
  end;
end;

procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  lbxOutput.Clear;
end;

procedure TfrmMain.ModbusTcpClient1SocketConnect(Sender: TObject);
var
  S: string;
begin
  S := (Sender as TTcpClient).RemoteHost;
  lbxOutput.Items.Add('Connected to: ' + S);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1SocketDisconnect(Sender: TObject);
var
  S: string;
begin
  S := (Sender as TTcpClient).RemoteHost;
  lbxOutput.Items.Add('Disonnected from: ' + S);
end;

procedure TfrmMain.ModbusTcpClient1SocketConnectionAborted(Sender: TObject);
var
  S: string;
begin
  S := (Sender as TTcpClient).RemoteHost;
  lbxOutput.Items.Add('Connection aborted from: ' + S);
end;

procedure TfrmMain.ModbusTcpClient1SocketError(Sender: TObject; SocketError:
    Integer);
var
  S: string;
begin
  S := Format('Socket error %d: %s', [SocketError,
      SocketErrorDesc(SocketError)]);
  lbxOutput.Items.Add(S);
end;

procedure TfrmMain.btnExecuteClick(Sender: TObject);
var
  ModbusFunction: Integer;
  Index: Integer;
begin
  // get start time
  FStartTime := GetTimeCounter;

  // parametrize ModbusTcpClient
  ModbusTcpClient1.RemoteHost := edtRemoteHost.Text;

  Index :=cboFunction.ItemIndex;
  ModbusFunction :=IndexToModbusfunction(Index);
  case ModbusFunction of
    READ_COILS: DoReadCoils;
    READ_INPUT_DISCRETES: DoReadInputDiscretes;
    READ_MULTIPLE_REGISTERS: DoReadMultipleRegisters;
    READ_INPUT_REGISTERS: DoReadInputRegisters;
    WRITE_COIL: DoWriteCoil;
    WRITE_SINGLE_REGISTER: DoWriteSingleRegister;
    READ_EXCEPTION_STATUS: DoReadExceptionStatus;
    GET_COMM_EVENT_COUNTER: DoGetCommEventCounter;
    FORCE_MULTIPLE_COILS: DoForceMultipleCoils;
    WRITE_MULTIPLE_REGISTERS: DoWriteMultipleRegisters;
    READ_WRITE_REGISTERS: DoReadWriteRegisters;
  end; { case }
  if cbxAutoIncrement.Checked then
    TransactionId := (TransactionId + 1) and $FFFF;
end;

function TfrmMain.GetBitValue: Boolean;
begin
  Result :=(cboBitValue.ItemIndex <> 0);
end;

function TfrmMain.GetByteCount: Integer;
begin
  Result :=Count shr 3;
  if (Count and $07) > 0 then
    Result := Result + 1;
end;

function TfrmMain.GetRefNum: Word;
begin
  Result :=StrToIntDef(edtRefNum.Text, 0);
end;

function TfrmMain.GetRegisterValue: Word;
begin
  Result :=StrToInt(edtRegisterValue.Text);
end;

function TfrmMain.GetTransactionId: Word;
begin
  Result :=StrToInt(edtTransactionId.Text);
end;

function TfrmMain.GetUnitId: Byte;
begin
  Result :=StrToInt(edtUnitId.Text);
end;

procedure TfrmMain.SetBitValue(const Value: Boolean);
var
  Index: Integer;
begin
  if Value then Index :=1 else Index :=0;
  cboBitValue.ItemIndex :=Index;
end;

procedure TfrmMain.SetBytePerLine(const Value: Integer);
begin
  if Value <>FBytePerLine then
  begin
    if Value < 1 then
      raise ERangeError.Create('Invalid value');
    FBytePerLine := Value;
  end;
end;

procedure TfrmMain.SetRefNum(const Value: Word);
begin
  edtRefNum.Text :=IntToStr(Value);
end;

procedure TfrmMain.SetRegisterValue(const Value: Word);
begin
  edtRegisterValue.Text :=IntToStr(Value);
end;

procedure TfrmMain.SetTransactionId(const Value: Word);
begin
  edtTransactionId.Text :=IntToStr(Value);
end;

procedure TfrmMain.SetUnitId(const Value: Byte);
begin
  edtUnitId.Text :=IntToStr(Value);
end;

procedure TfrmMain.SetWordPerLine(const Value: Integer);
begin
  if Value <>FWordPerLine then
  begin
    if Value < 1 then
      raise ERangeError.Create('Invalid value');
    FWordPerLine := Value;
  end;
end;

function TfrmMain.GetCount: Word;
begin
  Result :=StrToInt(edtCount.Text);
end;

procedure TfrmMain.SetCount(const Value: Word);
begin
  edtCount.Text :=IntToStr(Value);
end;

procedure TfrmMain.ShowEmptyLine;
begin
  ShowLine('');
end;

procedure TfrmMain.ShowFunctionHead(TransactionId: Word; UnitId, FunctionCode:
    Byte);
var
  Text: string;
  ResponseTime: TDateTime;
  ResponseTimeStamp: TTimeStamp;
begin
  // calculate response time
  ResponseTimeStamp := MsecsToTimeStamp(GetTimeCounter - FStartTime);
  ResponseTimeStamp.Date := 1;
  ResponseTime :=TimeStampToDateTime(ResponseTimeStamp);
  // show response time
  ShowLine(FormatDateTime('"Response time: "s.zzz" s"', ResponseTime));

  Text :=Format('Transaction Id: %d = (%0:0.4x)hex', [TransactionId]);
  ShowLine(Text);
  Text :=Format('Unit Id: %d', [UnitId]);
  ShowLine(Text);
  if FunctionCode <> 0 then
  begin
    Text :=Format('Modbus function: %d (%s)',
        [FunctionCode, ModbusFunctionToStr(FunctionCode)]);
    ShowLine(Text);
  end;
end;

procedure TfrmMain.ShowLine(const S: string);
begin
  lbxOutput.Items.Add(S);
end;

procedure TfrmMain.DumpByteArray(Address: Integer; Data: array of Byte);
var
  Len: Integer;
  BytePos: Integer;

  procedure DumpLine(Count: Integer);
  var
    Text: string;
    I: Integer;
  begin
    Text :=Format('%0.4x:', [Address]);
    for I :=0 to Count -1 do
    begin
      Text :=Text +Format(' %0.2x', [Data[BytePos]]);
      BytePos :=BytePos +1;
    end;
    Address :=Address +Count;
    ShowLine(Text);
  end;

begin
  Len :=Length(Data);
  BytePos :=Low(Data);
  while BytePos < Len do
  begin
    if Len -BytePos > BytePerLine then
      DumpLine(BytePerLine)
    else
      DumpLine(Len -BytePos);
  end;
end;

procedure TfrmMain.DumpWordArray(Address: Integer; Data: array of Word);
var
  Len: Integer;
  WordPos: Integer;

  procedure DumpLine(Count: Integer);
  var
    Text: string;
    I: Integer;
  begin
    Text :=Format('%0.4x:', [Address]);
    for I :=0 to Count -1 do
    begin
      Text :=Text +Format(' %0.4x', [Data[WordPos]]);
      WordPos :=WordPos +1;
    end;
    Address :=Address +Count;
    ShowLine(Text);
  end;

begin
  Len :=Length(Data);
  WordPos :=Low(Data);
  while WordPos < Len do
  begin
    if Len -WordPos > WordPerLine then
      DumpLine(WordPerLine)
    else
      DumpLine(Len -WordPos);
  end;
end;

procedure TfrmMain.DoReadCoils;
begin
  ModbusTcpClient1.ReadCoils(TransactionId, RefNum, Count, UnitId);
end;

procedure TfrmMain.DoForceMultipleCoils;
var
  Data: array of Byte;
  I: Integer;
  Size: Integer;
begin
  SetLength(Data, ByteCount);
  // read from data input array
  Size := ByteCount - 1;
  if Size > 7 then Size := 7;
  for I := 0 to Size do
  begin
    Data[I] := StrToInt(edtData[I].Text);
  end;

  ModbusTcpClient1.ForceMultipleCoils(TransactionId, RefNum, Count,
      Data, UnitId);
end;

procedure TfrmMain.DoGetCommEventCounter;
begin
  ModbusTcpClient1.GetCommEventCounter(TransactionId, UnitId);
end;

procedure TfrmMain.DoReadExceptionStatus;
begin
  ModbusTcpClient1.ReadExceptionStatus(TransactionId, UnitId);
end;

procedure TfrmMain.DoReadInputDiscretes;
begin
  ModbusTcpClient1.ReadInputDiscretes(TransactionId, RefNum, Count, UnitId);
end;

procedure TfrmMain.DoReadInputRegisters;
begin
  ModbusTcpClient1.ReadInputRegisters(TransactionId, RefNum,
      Count, UnitId);
end;

procedure TfrmMain.DoReadMultipleRegisters;
begin
  ModbusTcpClient1.ReadMultipleRegisters(TransactionId, RefNum,
      Count, UnitId);
end;

procedure TfrmMain.DoWriteCoil;
begin
  ModbusTcpClient1.WriteCoil(TransactionId, RefNum, BitValue, UnitId);
end;

procedure TfrmMain.DoWriteMultipleRegisters;
var
  Data: array of Word;
  I: Integer;
  Size: Integer;
begin
  SetLength(Data, Count);
  // read from data input array
  Size := Count - 1;
  if Size > 7 then Size := 7;
  for I := 0 to Size do
  begin
    Data[I] := StrToInt(edtData[I].Text);
  end;

  ModbusTcpClient1.WriteMultipleRegisters(TransactionId, RefNum, Count,
      Data, UnitId);
end;

procedure TfrmMain.DoReadWriteRegisters;
var
  Data: array of Word;
  I: Integer;
  Size: Integer;
begin
  SetLength(Data, Count);
  // read from data input array
  Size := Count - 1;
  if Size > 7 then Size := 7;
  for I := 0 to Size do
  begin
    Data[I] := StrToInt(edtData[I].Text);
  end;

  ModbusTcpClient1.ReadWriteRegisters(TransactionId, ReadRefNum,
      ReadCount, RefNum, Count, Data, UnitId);
end;

procedure TfrmMain.DoWriteSingleRegister;
begin
  ModbusTcpClient1.WriteSingleRegister(TransactionId, RefNum, RegisterValue,
      UnitId);
end;

procedure TfrmMain.ModbusTcpClient1Exception(Sender: TObject; TransactionId:
    Word; UnitId, FunctionCode, ExceptionCode: Byte);
var
  Text: string;
begin
  ShowLine('Exception');
  ShowFunctionHead(TransactionId, UnitId, FunctionCode);
  Text :=Format('Exception code: %d (%s)',
      [ExceptionCode, ModbusExceptionToStr(ExceptionCode)]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1Response(Sender: TObject; TransactionId:
    Word; UnitId, FunctionCode: Byte; Data: array of Byte);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, FunctionCode);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpByteArray(0, Data);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadCoils(Sender: TObject; TransactionId:
    Word; UnitId: Byte; Data: array of Byte);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_COILS);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpByteArray(0, Data);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ForceMultipleCoils(Sender: TObject;
    TransactionId: Word; UnitId: Byte; RefNum, BitCount: Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, FORCE_MULTIPLE_COILS);
  Text :=Format('Reference Number: %d = (%0:0.4x)hex', [RefNum]);
  ShowLine(Text);
  Text :=Format('Bit count: %d = (%0:0.4x)hex', [BitCount]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1GetCommEventCounter(Sender: TObject;
    TransactionId: Word; UnitId: Byte; Status, Count: Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, GET_COMM_EVENT_COUNTER);
  Text :=Format('Status: %d', [Status]);
  ShowLine(Text);
  Text :=Format('Event count: %d', [Count]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadExceptionStatus(Sender: TObject;
    TransactionId: Word; UnitId, Status: Byte);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_EXCEPTION_STATUS);
  Text :=Format('Status: %d = (%0:0.2x)hex', [Status]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadInputDiscretes(Sender: TObject;
    TransactionId: Word; UnitId: Byte; Data: array of Byte);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_INPUT_DISCRETES);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpByteArray(0, Data);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadInputRegisters(Sender: TObject;
    TransactionId: Word; UnitId: Byte; Data: array of Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_INPUT_REGISTERS);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpWordArray(0, Data);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadMultipleRegisters(Sender: TObject;
    TransactionId: Word; UnitId: Byte; Data: array of Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_MULTIPLE_REGISTERS);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpWordArray(0, Data);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1WriteCoil(Sender: TObject; TransactionId:
    Word; UnitId: Byte; RefNum: Word; Value: Boolean);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, WRITE_COIL);
  Text :=Format('Reference Number: %d = (%0:0.4x)hex', [RefNum]);
  ShowLine(Text);
  Text :=Format('Value: %s', [BooleanToStr(Value)]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1WriteMultipleRegisters(Sender: TObject;
    TransactionId: Word; UnitId: Byte; RefNum, WordCount: Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, WRITE_MULTIPLE_REGISTERS);
  Text :=Format('Reference Number: %d = (%0:0.4x)hex', [RefNum]);
  ShowLine(Text);
  Text :=Format('Word count: %d = (%0:0.4x)hex', [WordCount]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1WriteSingleRegister(Sender: TObject;
    TransactionId: Word; UnitId: Byte; RefNum, Value: Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, WRITE_SINGLE_REGISTER);
  Text :=Format('Reference Number: %d = (%0:0.4x)hex', [RefNum]);
  ShowLine(Text);
  Text :=Format('Value: %d = (%0:0.4x)hex', [Value]);
  ShowLine(Text);
  ShowEmptyLine;
end;

procedure TfrmMain.ModbusTcpClient1ReadWriteRegisters(Sender: TObject; 
    TransactionId: Word; UnitId: Byte; Data: array of Word);
var
  Text: string;
begin
  ShowFunctionHead(TransactionId, UnitId, READ_WRITE_REGISTERS);
  Text :='Data (hex):';
  ShowLine(Text);
  DumpWordArray(0, Data);
  ShowEmptyLine;
end;

function TfrmMain.GetedtData(Index: Integer): TEdit;
begin
  Result := FindComponent(Format('edtData%d', [Index])) as TEdit;
end;

function TfrmMain.GetlblData(Index: Integer): TLabel;
begin
  Result := FindComponent(Format('lblData%d', [Index])) as TLabel;
end;

procedure TfrmMain.cboFunctionChange(Sender: TObject);
var
  ModbusFunction: Integer;
  Index: Integer;
  Parameters: TParameters;
begin
  Index :=cboFunction.ItemIndex;
  ModbusFunction :=IndexToModbusfunction(Index);
  case ModbusFunction of
    READ_COILS:
    begin
      Parameters :=[pmRefNum, pmCount];
      ValueSize :=vsByte;
    end;
    READ_INPUT_DISCRETES:
    begin
      Parameters :=[pmRefNum, pmCount];
      ValueSize :=vsByte;
    end;
    READ_MULTIPLE_REGISTERS:
    begin
      Parameters :=[pmRefNum, pmCount];
      ValueSize :=vsWord;
    end;
    READ_INPUT_REGISTERS:
    begin
      Parameters :=[pmRefNum, pmCount];
      ValueSize :=vsWord;
    end;
    WRITE_COIL:
      Parameters :=[pmRefNum, pmBitValue];
    WRITE_SINGLE_REGISTER:
      Parameters :=[pmRefNum, pmRegisterValue];
    READ_EXCEPTION_STATUS:
      Parameters :=[];
    GET_COMM_EVENT_COUNTER:
      Parameters :=[];
    FORCE_MULTIPLE_COILS:
    begin
      Parameters :=[pmRefNum, pmCount, pmData];
      ValueSize :=vsByte;
    end;
    WRITE_MULTIPLE_REGISTERS:
    begin
      Parameters :=[pmRefNum, pmCount, pmData];
      ValueSize :=vsWord;
    end;
    READ_WRITE_REGISTERS:
    begin
      Parameters :=[pmRefNum, pmCount, pmReadRefNum, pmReadCount, pmData];
      ValueSize :=vsWord;
    end;
  end; { case }
  SetParameters(Parameters);
end;

procedure TfrmMain.SetParameters(Parameters: TParameters);
var
  Visible: Boolean;
  I: Integer;
begin
  lblRefNum.Enabled := pmRefNum in Parameters;
  edtRefNum.Visible := lblRefNum.Enabled;

  lblCount.Enabled := pmCount in Parameters;
  edtCount.Visible := lblCount.Enabled;

  lblReadRefNum.Enabled := pmReadRefNum in Parameters;
  edtReadRefNum.Visible := lblReadRefNum.Enabled;

  lblReadCount.Enabled := pmReadCount in Parameters;
  edtReadCount.Visible := lblReadCount.Enabled;

  lblBitValue.Enabled := pmBitValue in Parameters;
  cboBitValue.Visible := lblBitValue.Enabled;

  lblRegisterValue.Enabled := pmRegisterValue in Parameters;
  edtRegisterValue.Visible := lblRegisterValue.Enabled;

  Visible := pmData in Parameters;
  for I := 0 to 7 do
  begin
    edtData[I].Visible := Visible;
    lblData[I].Visible := Visible;
  end;

  case ValueSize of
    vsByte: lblCount.Caption :=sCaptionBitCount;
    vsWord: lblCount.Caption :=sCaptionRegisterCount;
  end;

  edtRefNumChange(edtCount);
end;

function TfrmMain.GetDataCaption(Index: Integer): string;
var
  lRefNum: Integer;
begin
  // calculate reference number
  if ValueSize = vsByte then
    lRefNum := RefNum + Index * 8
  else
    lRefNum := RefNum + Index;

  // format data caption
  Result := Format('$%0.4x', [lRefNum]);
end;

procedure TfrmMain.edtRefNumChange(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to 7 do
    lblData[i].Caption := GetDataCaption(I);
end;

procedure TfrmMain.edtRefNumExit(Sender: TObject);
begin
  edtRefNumChange(Sender);
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.FillcboFunction;
var
  I: Integer;
  ModbusFunction: Integer;
begin
  cboFunction.Clear;
  for I := 0 to 10 do
  begin
    ModbusFunction := IndexToModbusFunction(I);
    cboFunction.Items.Add(Format('(%d)%s', [ModbusFunction,
        ModbusFunctionToStr(ModbusFunction)]));
  end;
end;

function TfrmMain.GetReadRefNum: Word;
begin
  Result :=StrToIntDef(edtReadRefNum.Text, 0);
end;

procedure TfrmMain.SetReadRefNum(const Value: Word);
begin
  edtReadRefNum.Text :=IntToStr(Value);
end;

function TfrmMain.GetReadCount: Word;
begin
  Result :=StrToInt(edtReadCount.Text);
end;

procedure TfrmMain.SetReadCount(const Value: Word);
begin
  edtReadCount.Text :=IntToStr(Value);
end;

procedure TfrmMain.ApplicationIdle(Sender: TObject; var Done: Boolean);
begin
{$IFDEF DOS}
  // periodical network update is essencial for WDOSX mode applications
  Sockets.UpdateNetwork;
{$ENDIF}
end;


end.

