unit MainForm;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, Rio, SOAPHTTPClient, Euro, InvokeRegistry,
  IniFiles;

type
  TfrmMain = class(TForm)
    btnToEuro: TButton;
    btnFromEuro: TButton;
    edtOutput: TEdit;
    edtInput: TEdit;
    rgrCurrency: TRadioGroup;
    HTTPRIO1: THTTPRIO;
    edtProxy: TEdit;
    lblProxy: TLabel;
    lblUri: TLabel;
    edtUri: TEdit;
    procedure btnFromEuroClick(Sender: TObject);
    procedure btnToEuroClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Initialized: Boolean;
  public
    procedure SetProxy;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.xfm}

const
  IniFileName = '.\Euro42CL.ini';
  SectionData = 'Data';
  KeyUri = 'URI';
  KeyProxy = 'Proxy';


procedure TfrmMain.btnFromEuroClick(Sender: TObject);
begin
  SetProxy;
  edtOutput.Text := FloatToStr(
      (HTTPRIO1 AS IEuro).FromEuro(
      rgrCurrency.Items[rgrCurrency.ItemIndex],
      StrToFloat(edtInput.Text))) + #32 +
      rgrCurrency.Items[rgrCurrency.ItemIndex];
end;

procedure TfrmMain.btnToEuroClick(Sender: TObject);
begin
  SetProxy;
  edtOutput.Text := FloatToStr(
      (HTTPRIO1 AS IEuro).ToEuro(
      rgrCurrency.Items[rgrCurrency.ItemIndex],
      StrToFloat(edtInput.Text))) + ' EUR';
end;

procedure TfrmMain.SetProxy;
begin
  HTTPRIO1.HTTPWebNode.Proxy := edtProxy.Text;
  HTTPRIO1.WSDLLocation := edtUri.Text;
end;

procedure TfrmMain.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if not Initialized then
  begin
    Initialized := TRUE;
    IniFile := TIniFile.Create(IniFileName);
    edtUri.Text := IniFile.ReadString(SectionData, KeyUri,
        'http://www.drbob42.co.uk/cgi-bin/Euro42/wsdl/IEuro');
    edtProxy.Text := IniFile.ReadString(SectionData, KeyProxy,
        'fli4l:3128');
    IniFile.Free;
  end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(IniFileName);
  IniFile.WriteString(SectionData, KeyUri, edtUri.Text);
  IniFile.WriteString(SectionData, KeyProxy, edtProxy.Text);
  IniFile.UpdateFile;
  IniFile.Free;
end;

end.
