{ Invokable-Implementierungsdatei fr TEuro das IEuro implementiert }

unit EuroImpl;

interface

uses InvokeRegistry, Types, XSBuiltIns, EuroIntf;

const
  EuroCountries = 12;

type
  TEuroCurrency = record
    Currency: String[3];
    Conversion: Double;
  end;

const
  Currencies: Array[1..EuroCountries] of TEuroCurrency = (
     (Currency: 'FIM'; Conversion: 5.94573),
     (Currency: 'ITL'; Conversion: 1936.27),
     (Currency: 'NLG'; Conversion: 2.20371),
     (Currency: 'ESP'; Conversion: 166.386),
     (Currency: 'BEF'; Conversion: 40.3399),
     (Currency: 'ATS'; Conversion: 13.7603),
     (Currency: 'LUF'; Conversion: 40.3399),
     (Currency: 'DEM'; Conversion: 1.95583),
     (Currency: 'FRF'; Conversion: 6.55957),
     (Currency: 'IEP'; Conversion: 0.787564),
     (Currency: 'PTE'; Conversion: 200.482),
     (Currency: 'GRO'; Conversion: 340.750));

type
  { TEuro }
  TEuro = class(TInvokableClass, IEuro)
    function FromEuro(const Currency: WideString; Amount: Double): Double; stdcall;
    function ToEuro(const Currency: WideString; Amount: Double): Double; stdcall;
  end;

implementation

{ TEuro }

function TEuro.FromEuro(const Currency: WideString; Amount: Double): Double;
var
  curr:  Integer;
begin
  curr := 1;
  while (curr <= EuroCountries) and
   (Currencies[curr].Currency <> Currency) do Inc(curr);
  if curr <= EuroCountries then
    Result := Amount * Currencies[curr].Conversion
  else Result := 0 { invalid country code }
end;

function TEuro.ToEuro(const Currency: WideString; Amount: Double): Double;
var
  curr:  Integer;
begin
  curr := 1;
  while (curr <= EuroCountries) and
   (Currencies[curr].Currency <> Currency) do Inc(curr);
  if curr <= EuroCountries then
    Result := Amount / Currencies[curr].Conversion
  else Result := 0 { invalid country code }
end;

initialization
  { Invokable-Klassen mssen registriert sein }
  InvRegistry.RegisterInvokableClass(TEuro);

end.
