
  {****************************************************}
  {                                                    }
  {              Delphi XML Data Binding               }
  {                                                    }
  {         Generated on: 2001/11/07 00:37:00          }
  {       Generated from: D:\D6Clinic\src\Clinic.xml   }
  {   Settings stored in: D:\D6Clinic\src\Clinic.xdb   }
  {                                                    }
  {****************************************************}

unit Clinic;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ Forward-Deklarationen }

  IXMLClinicsType = interface;
  IXMLClinicType = interface;

{ IXMLClinicsType }

  IXMLClinicsType = interface(IXMLNodeCollection)
    ['{51B2F2E6-5A04-42E2-A0DA-F24804802A47}']
    { Eigenschaftszugriff }
    function Get_Clinic(Index: Integer): IXMLClinicType;
    { Methoden & Eigenschaften }
    function Add: IXMLClinicType;
    function Insert(const Index: Integer): IXMLClinicType;
    property Clinic[Index: Integer]: IXMLClinicType read Get_Clinic; default;
  end;

{ IXMLClinicType }

  IXMLClinicType = interface(IXMLNode)
    ['{0E81CDFB-43A9-48DD-B4D4-A02B00D73811}']
    { Eigenschaftszugriff }
    function Get_No: WideString;
    function Get_Title: WideString;
    function Get_Date: WideString;
    function Get_Topics: WideString;
    procedure Set_No(Value: WideString);
    procedure Set_Title(Value: WideString);
    procedure Set_Date(Value: WideString);
    procedure Set_Topics(Value: WideString);
    { Methoden & Eigenschaften }
    property No: WideString read Get_No write Set_No;
    property Title: WideString read Get_Title write Set_Title;
    property Date: WideString read Get_Date write Set_Date;
    property Topics: WideString read Get_Topics write Set_Topics;
  end;

{ Forward-Deklarationen }

  TXMLClinicsType = class;
  TXMLClinicType = class;

{ TXMLClinicsType }

  TXMLClinicsType = class(TXMLNodeCollection, IXMLClinicsType)
  protected
    { IXMLClinicsType }
    function Get_Clinic(Index: Integer): IXMLClinicType;
    function Add: IXMLClinicType;
    function Insert(const Index: Integer): IXMLClinicType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLClinicType }

  TXMLClinicType = class(TXMLNode, IXMLClinicType)
  protected
    { IXMLClinicType }
    function Get_No: WideString;
    function Get_Title: WideString;
    function Get_Date: WideString;
    function Get_Topics: WideString;
    procedure Set_No(Value: WideString);
    procedure Set_Title(Value: WideString);
    procedure Set_Date(Value: WideString);
    procedure Set_Topics(Value: WideString);
  end;

{ Globale Funktionen }

function GetClinics(Doc: IXMLDocument): IXMLClinicsType;
function LoadClinics(const FileName: WideString): IXMLClinicsType;
function NewClinics: IXMLClinicsType;

const
  TargetNamespace = '';

implementation

{ Globale Funktionen }

function GetClinics(Doc: IXMLDocument): IXMLClinicsType;
begin
  Result := Doc.GetDocBinding('Clinics', TXMLClinicsType, TargetNamespace) as IXMLClinicsType;
end;

function LoadClinics(const FileName: WideString): IXMLClinicsType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('Clinics', TXMLClinicsType, TargetNamespace) as IXMLClinicsType;
end;

function NewClinics: IXMLClinicsType;
begin
  Result := NewXMLDocument.GetDocBinding('Clinics', TXMLClinicsType, TargetNamespace) as IXMLClinicsType;
end;

{ TXMLClinicsType }

procedure TXMLClinicsType.AfterConstruction;
begin
  RegisterChildNode('Clinic', TXMLClinicType);
  ItemTag := 'Clinic';
  ItemInterface := IXMLClinicType;
  inherited;
end;

function TXMLClinicsType.Get_Clinic(Index: Integer): IXMLClinicType;
begin
  Result := List[Index] as IXMLClinicType;
end;

function TXMLClinicsType.Add: IXMLClinicType;
begin
  Result := AddItem(-1) as IXMLClinicType;
end;

function TXMLClinicsType.Insert(const Index: Integer): IXMLClinicType;
begin
  Result := AddItem(Index) as IXMLClinicType;
end;

{ TXMLClinicType }

function TXMLClinicType.Get_No: WideString;
begin
  Result := AttributeNodes['No'].Text;
end;

procedure TXMLClinicType.Set_No(Value: WideString);
begin
  SetAttribute('No', Value);
end;

function TXMLClinicType.Get_Title: WideString;
begin
  Result := ChildNodes['Title'].Text;
end;

procedure TXMLClinicType.Set_Title(Value: WideString);
begin
  ChildNodes['Title'].NodeValue := Value;
end;

function TXMLClinicType.Get_Date: WideString;
begin
  Result := ChildNodes['Date'].Text;
end;

procedure TXMLClinicType.Set_Date(Value: WideString);
begin
  ChildNodes['Date'].NodeValue := Value;
end;

function TXMLClinicType.Get_Topics: WideString;
begin
  Result := ChildNodes['Topics'].Text;
end;

procedure TXMLClinicType.Set_Topics(Value: WideString);
begin
  ChildNodes['Topics'].NodeValue := Value;
end;

end.