unit frmuXml2;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, xmldom, XMLIntf, oxmldom, XMLDoc, Clinic;

type
  TfrmMain = class(TForm)
    XMLDocument1: TXMLDocument;
    ButtonGet: TButton;
    EditNo: TEdit;
    Label1: TLabel;
    EditTitle: TEdit;
    Label2: TLabel;
    EditDate: TEdit;
    Label3: TLabel;
    EditTopics: TEdit;
    Label4: TLabel;
    ButtonPut: TButton;
    ButtonAdd: TButton;
    ButtonNext: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonGetClick(Sender: TObject);
    procedure ButtonPutClick(Sender: TObject);
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
  private
    Clinics: IXMLClinicsType;
    Current: Integer;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.xfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Clinics := GetClinics(XMLDocument1);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  XMLDocument1.SaveToFile;
end;

procedure TfrmMain.ButtonGetClick(Sender: TObject);
begin
  Current := -1;
  ButtonNext.Click;
end;

procedure TfrmMain.ButtonPutClick(Sender: TObject);
var
  Clinic: IXMLClinicType;
begin
  Clinic := Clinics.Clinic[Current];
  Clinic.No := EditNo.Text;
  Clinic.Title := EditTitle.Text;
  Clinic.Date := EditDate.Text;
  Clinic.Topics := EditTopics.Text;
end;

procedure TfrmMain.ButtonAddClick(Sender: TObject);
begin
  with Clinics.Add do
  begin
    No := '2001-2-8';  // 8th Clinic of the 2nd series of 2001
    Title := 'Special Kylix 2 Clinic';
    Date := '2001/12/21';
    Topics := 'Kylix 2 New Features'
  end
end;

procedure TfrmMain.ButtonNextClick(Sender: TObject);
var
  Clinic: IXMLClinicType;
begin
  Inc(Current);
  if Current = Clinics.Count then Current := 0;
  Clinic := Clinics.Clinic[Current];
  EditNo.Text := Clinic.No;
  EditTitle.Text := Clinic.Title;
  EditDate.Text := Clinic.Date;
  EditTopics.Text := Clinic.Topics;
end;

end.
