program TPP1;

{$APPTYPE CONSOLE}

{ 
  This project is a demo project from Kevin R. Smith for "Delphi1 DOS".
  See file "DelphDos.zip".

  I know there is probably crappy code in here but I was just trying to
  test features not create an application

  Adapted for Delphi 5 and 6 by Immo Wache, 2001-10-18
}

uses
  SysUtils, Classes;

var
  ca: string;
  f: file;
  n: LongInt; // it also works with Integer

procedure TypInfoTest;
var
  comp: TComponent;
  strm: TStream;
begin
  if FileExists('TPPTEST.BIN') then
  begin
    {- load -}
    strm := TFileStream.Create( 'TPPTEST.BIN', fmOpenRead );
    comp := strm.ReadComponent( nil );
    strm.Free;
    WriteLn( 'ComponentName: ', comp.Name );
    if (comp is TPersistent) then WriteLn( 'It''s persistent!' );
    comp.Free;
  end
  else
  begin
    {- create -}
    comp := TComponent.Create( nil );
    comp.Name := 'Component1';
    comp.Tag := 9999;
    strm := TFileStream.Create( 'TPPTEST.BIN', fmCreate );
    strm.WriteComponent( comp );
    strm.Free;
    comp.Free;
  end;
end;


procedure ConvertTest;
var
  xxx: TStream;
  yyy: TStream;
begin
  xxx := nil;
  yyy := nil;
  try
    try
      xxx := TFileStream.Create('TPPTEST.BIN', fmOpenRead);
      yyy := TFileStream.Create('TPPTEST.TXT', fmCreate);
    except
      WriteLn('Failed creating TPPTEST.TXT');
      Exit; { exit in this case jumps to "finally" }
    end;
    ObjectBinaryToText(xxx, yyy);
  finally
    xxx.Free;
    yyy.Free;
  end;
end;

procedure Run;
begin
  ca := 'abcdefghi';
  ca := StrToOem(ca);

  WriteLn( ca );
  WriteLn( LongDayNames[1] );

  TypInfoTest;
  ConvertTest;

  Assign( f, 'XYZ.FIL');
  try
    Reset( f );
    WriteLn('File XYZ.FIL is open');
    Close( f );
  except
    on E : EInOutError do
      WriteLn('Cannot open XYZ.FIL, IOError: ', E.ErrorCode);
  end;

  n := 0;
  try
    n := 10 div n;
  except
    on EDivByZero do
      WriteLn('Divide By 0')
  end;
end;


{------------------------------------------------------------------------------}

{ the "try run except" block is a good concept for DOS Delphi programs
  because there is no default exception handling built in.  In windows
  it is part of TApplication.Run }
begin
  RegisterClass(TComponent); { used for strm.ReadComponent(nil) above }
{$IFDEF MSWINDOWS}
  DebugHook := 0;
{$ENDIF}
  try
    Run;
  except
    on E : Exception do
      WriteLn('Exception raised: ', E.Message)
  end
end.

