program CRS1;

{$APPTYPE CONSOLE}

uses
  Crt,
  Threads,
  MyThreads in 'MyThreads.pas';

type
  TList = class
    procedure Terminate(Sender: TObject);
  end;

procedure TList.Terminate(Sender: TObject);
begin
  Writeln(Sender.ClassName + ' terminated - Press Enter...');
  Readln; // <-- this is only for test, don't use Readln with Threads
end;

var
  List: TList;
  ThreadOne: TThreadOne;
  ThreadTwo: TThreadTwo;
begin
  List := TList.Create;
  // create suspended
  ThreadOne := TThreadOne.Create(True);
  ThreadOne.Name := 'Thread 1';
  ThreadOne.OnTerminate := List.Terminate;
  // create not suspended
  ThreadTwo := TThreadTwo.Create(False);
  ThreadTwo.OnTerminate := List.Terminate;

  repeat
    Sleep(0);
    if KeyPressed then
      case ReadKey of
        '1':
          begin
            if ThreadOne.Suspended then
              ThreadOne.Resume
            else
              ThreadOne.Suspend;
          end;
        '2':
          begin
            if ThreadTwo.Suspended then
              ThreadTwo.Resume
            else
              ThreadTwo.Suspend;
          end;
        '3': ThreadTwo.Terminate;
        #27: Break;
      end;
  until False;

  ThreadOne.Free;
  ThreadTwo.Free;
  List.Free;
end.

