
{*******************************************************}
{                                                       }
{ DWPL Delphi WDosX and Cross Platform Library (rtl)    }
{ GETMEM.INC                                            }
{                                                       }
{ for Delphi 6                                          }
{ Version 2.0                                           }
{ Copyright (c) 2002 by Team-DWP                        }
{ e-mail: team-dwp@dwp42.org                            }
{ www: http://www.dwp42.org                             }
{                                                       }
{ The initial developer of the code is                  }
{   Laszlo Agocs alp@dwp42.org                          }
{                                                       }
{ Portions created by Laszlo Agocs are                  }
{ Copyright (C) 2002 Laszlo Agocs.                      }
{                                                       }
{ Contributor(s):                                       }
{   Immo Wache immo.wache@dwp42.org                     }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ Licensees holding a valid Team-DWP No-Nonsense        }
{ License for this Software may use this file in        }
{ accordance with such license, which appears in        }
{ the file license.txt that came with this software.    }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/sys/GETMEM.INC,v 1.5 2003/01/04 15:38:53 lagocs Exp $
  ----------------------------------------------------------------------------

  $Log: GETMEM.INC,v $
  Revision 1.5  2003/01/04 15:38:53  lagocs
  d4 support in getmem.inc

  Revision 1.4  2002/11/05 19:22:11  lagocs
  WDosMM moved to memmgr. Common getmem.inc for D5 and 6. Crt units are renamed to
  Crt.old.

  Revision 1.3  2002/10/27 22:48:30  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
{
  This include file replaces the non-GPL memory manager with a
  Borland C 5.0 created DLL, it uses the memory manager of the
  BC RTL. So you can compile DWPL with D6PE and without the nasty
  memory manager bug under Win9x/ME.
}

{$ifdef VER130}
type
  DWORD = Integer;
  BOOL  = LongBool;
{$endif}
{$ifdef VER120}
type
  DWORD = Integer;
  BOOL  = LongBool;
{$endif}

const
  MemMgr = 'memmgr.dll';

function Alloc(Size: Integer): Pointer; stdcall; external MemMgr
    name 'alp_malloc';
procedure Free(P: Pointer); stdcall; external MemMgr
    name 'alp_free';
function ReAlloc(P: Pointer; NewSize: Integer): Pointer; stdcall;
    external MemMgr name 'alp_realloc';

const

// Heap error codes

  cHeapOk           = 0;          // everything's fine

function SysGetMem(Size: Integer): Pointer;
begin
  Result := Alloc(Size);
end;

function SysFreeMem(P: Pointer): Integer;
begin
  Free(P);
  Result := 0;
end;

function SysReallocMem(P: Pointer; Size: Integer): Pointer;
begin
  Result := ReAlloc(P, Size);
end;

function GetHeapStatus: THeapStatus;
begin
  Result.TotalAddrSpace   := 0;
  Result.TotalUncommitted := 0;
  Result.TotalCommitted   := 0;
  Result.TotalAllocated   := 0;
  Result.TotalFree        := 0;
  Result.FreeSmall        := 0;
  Result.FreeBig          := 0;
  Result.Unused           := 0;
  Result.Overhead         := 0;
  Result.HeapErrorCode    := cHeapOk;
end;

function InitAllocator: Boolean;
// Initialize. No other calls legal before that.
begin
  Result := True;
end;

procedure UninitAllocator;
// Shutdown; do nothing.
begin
end;


