
{*******************************************************}
{                                                       }
{ DWPL Delphi Cross Platform Core Library (rtl)         }
{ WDosPorts.pas                                         }
{                                                       }
{ for Delphi 4, 5, 6                                    }
{ Version 2.0                                           }
{ Copyright (c) 2001 by Immo Wache                      }
{ e-mail: immo.wache@dwp42.org                          }
{ www: http://www.dwp42.org                             }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ this software contains portions from:                 }
{                                                       }
{   - WDOSX DOS Extender                                }
{     Copyright (c) 1996, 1998, Michael Tippach         }
{     e-mail: mtippach@gmx.net                          }
{     www: http://www.wuschel.demon.co.uk               }
{     Realeased under the terms of the WDOSX            }
{     license agreement.                                }
{                                                       }
{ Please inform you about special copyrights for these  }
{ portions on the apropriate web pages.                 }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/wdosx/WDosPorts.pas,v 1.2 2002/10/27 22:53:12 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: WDosPorts.pas,v $
  Revision 1.2  2002/10/27 22:53:12  iwache
  CVS tags "Header" and "Log" added.

  ----------------------------------------------------------------------------
}
{
  Version history:
    IWA 2001-08-21 some modifications for Delphi 6
    IWA 2001-05-25 Version 2.0.1.0 released
    IWA 2000-11-20 Version 1.1
}

unit WDosPorts;

interface

type
  TPort = class(TObject)
  private
    procedure SetPort(Index: Word; Data: Byte);
    function GetPort(Index: Word): Byte;
  public
    property Port[Index: Word]: Byte read GetPort write SetPort; default;
  end;

  TPortW = class(TObject)
  private
    procedure SetPortW(Index: Word; Value: Word);
    function GetPortW(Index: Word): Word;
  public
    property PortW[Index: Word]: Word read GetPortW write SetPortW; default;
  end;

  TPortL = class(TObject)
  private
    procedure SetPortL(Index: Word; Value: LongInt);
    function GetPortL(Index: Word): LongInt;
  public
    property PortL[Index: Word]: LongInt read GetPortL write SetPortL; default;
  end;

  TMemW = class(TObject)
  private
    function GetMemW(Index: LongInt): Word;
    procedure SetMemW(Index: LongInt; const Value: Word);
  public
    property MemW[Index: LongInt]: Word read GetMemW write SetMemW; default;
  end;

  TMemL = class(TObject)
  private
    function GetMemL(Index: LongInt): LongInt;
    procedure SetMemL(Index: LongInt; const Value: LongInt);
  public
    property MemL[Index: LongInt]: LongInt read GetMemL write SetMemL; default;
  end;

  TMem = class(TObject)
  private
    function GetMem(Index: LongInt): Byte;
    procedure SetMem(Index: LongInt; Value: Byte);
  public
    property Mem[Index: LongInt]: Byte read GetMem write SetMem; default;
  end;

var
  Port: TPort;
  PortW: TPortW;
  PortL: TPortL;
  Mem: TMem;
  MemW: TMemW;
  MemL: TMemL;

implementation

{ TPort }

function TPort.GetPort(Index: Word): Byte; register; assembler;
asm
        IN      AL,DX
end;

procedure TPort.SetPort(Index: Word; Data: Byte); register; assembler;
asm
        MOV     EAX,ECX
        OUT     DX,AL
end;

{ TPortW }

function TPortW.GetPortW(Index: Word): Word; register; assembler;
asm
        IN      AX,DX
end;

procedure TPortW.SetPortW(Index: Word; Value: Word); register; assembler;
asm
        MOV     EAX,ECX
        OUT     DX,AX
end;

{ TPortL }

function TPortL.GetPortL(Index: Word): LongInt; register; assembler;
asm
       IN       EAX,DX
end;

procedure TPortL.SetPortL(Index: Word; Value: Integer); register; assembler;
asm
        MOV     EAX,ECX
        OUT     DX,EAX
end;

{ TMemW }

function TMemW.GetMemW(Index: LongInt): Word; register; assembler;
asm
        MOV     AX,[EDX]
end;

procedure TMemW.SetMemW(Index: LongInt; const Value: Word); register; assembler;
asm
        MOV     [EDX],CX
end;

{ TMemL }

function TMemL.GetMemL(Index: LongInt): LongInt; register; assembler;
asm
        MOV     EAX,[EDX]
end;

procedure TMemL.SetMemL(Index: LongInt; const Value: LongInt); register;
    assembler;
asm
        MOV     [EDX],ECX
end;

function TMem.GetMem(Index: LongInt): Byte;
asm
        MOV     AL,[EDX]
end;

procedure TMem.SetMem(Index: LongInt; Value: Byte);
asm
        MOV     [EDX],CL
end;


initialization
  Port := TPort.Create;
  PortW := TPortW.Create;
  PortL := TPortL.Create;
  Mem := TMem.Create;
  MemW := TMemW.Create;
  MemL := TMemL.Create;

finalization
  Port.Free;
  PortW.Free;
  PortL.Free;
  Mem.Free;
  MemW.Free;
  MemL.Free;

end.
