
{*******************************************************}
{                                                       }
{ DWPL Delphi WDosX and Cross Platform Library (rtl)    }
{ WinPorts.pas                                          }
{                                                       }
{ for Delphi 5, 6, 7                                    }
{ Version 2.6.0                                         }
{ Copyright (c) 2003 by Team-DWP                        }
{ e-mail: team-dwp@dwp42.org                            }
{ www: http://www.dwp42.org                             }
{                                                       }
{ The initial developer of the code is                  }
{   Immo Wache, immo.wache@dwp42.org                    }
{                                                       }
{ This file may be distributed and/or modified under    }
{ the terms of the GNU General Public License (GPL)     }
{ version 2 as published by the Free Software           }
{ Foundation and appearing at                           }
{ http://www.dwp42.org/license/gpl.html.                }
{                                                       }
{ Licensees holding a valid Team-DWP No-Nonsense        }
{ License for this Software may use this file in        }
{ accordance with such license, which appears in        }
{ the file license.txt that came with this software.    }
{                                                       }
{*******************************************************}
{
  $Header: /cvsroot/dwpl/dwpl/source/rtl/win/WinPorts.pas,v 1.1 2003/10/11 21:06:11 iwache Exp $
  ----------------------------------------------------------------------------

  $Log: WinPorts.pas,v $
  Revision 1.1  2003/10/11 21:06:11  iwache
  Interface unit for access to the inpout32.dll.
  With this unit you can use Port[] array on all
  current Windows versions from Win9x to WinXP.

  ----------------------------------------------------------------------------
}

unit WinPorts;

interface

type
  TPort = class(TObject)
  private
    procedure SetPort(Index: Word; Value: Byte);
    function GetPort(Index: Word): Byte;
  public
    property Port[Index: Word]: Byte read GetPort write SetPort; default;
  end;

var
  Port: TPort;

function Inp32(Address: Word): Word; stdcall;
procedure Out32(Address: Word; Value: Word); stdcall;

implementation

const
  inpout = 'inpout32.dll';

function Inp32; external inpout name 'Inp32';
procedure Out32; external inpout name 'Out32';

function TPort.GetPort(Index: Word): Byte;
begin
  Result := Inp32(Index);
end;

procedure TPort.SetPort(Index: Word; Value: Byte);
begin
  Out32(Index, Value);
end;

initialization
  Port := TPort.Create;

finalization
  Port.Free;
  Port := nil;

end.
